/*

*/

import binarytree.*;

/**
   A program that builds a simple BTree data structure.
*/
public class Example_BTree_1
{
   public static void main(String[] args)
   {
      final BTree<String> btree = new BTreeLinked<>("a",
                                      new BTreeLinked<>("b"),
                                      new BTreeLinked<>("c"));

      System.out.println( btree );

      System.out.println( PrettyPrinter.prettyPrint( btree ) + "\n" );

      BTree2dot.btree2dot(btree, "example1");
      BTree2png.btree2png("example1");

      System.out.println("degree = " + btree.degree());
      System.out.println("height =  " + btree.height());
      System.out.println("size = " + btree.size());
      System.out.println("isFull = " + btree.isFull());

      System.out.println( btree.preOrder() );
      System.out.println( btree.inOrder() );
      System.out.println( btree.postOrder() );
   }
}
