/*

*/

import binarytree.*;

/**
   A program that builds a more complex BTree data structure.
*/
public class Example_BTree_2
{
   public static void main(String[] args)
   {
      final BTree<String> btree2 =
                 new LinkedBTree<>("a",
                           new LinkedBTree<>("b",
                                     new LinkedBTree<>("b1"),
                                     new LinkedBTree<>("b2",
                                               new LinkedBTree<>(), // empty tree
                                               new LinkedBTree<>("b22"))),
                           new LinkedBTree<>("c",
                                     new LinkedBTree<>("left"),
                                     new LinkedBTree<>("right")));

      System.out.println( btree2 );

      System.out.println( PrettyPrinter.prettyPrint( btree2 ) + "\n" );

      BTree2dot.btree2dot(btree2, "example2");
      BTree2png.btree2png("example2");

      System.out.println("degree = " + btree2.degree());
      System.out.println("height =  " + btree2.height());
      System.out.println("size = " + btree2.size());
      System.out.println("isFull = " + btree2.isFull());

      System.out.println( btree2.preOrder() );
      System.out.println( btree2.inOrder() );
      System.out.println( btree2.postOrder() );
   }
}
