/*

*/

import binarytree.*;

/**
   A program that builds three more BTree data structures.
*/
public class Example_BTree_3
{
   public static void main(String[] args)
   {
      final BTree<Integer> btree3 =
           new FullBTree<>(3,
               new FullBTree<>(4,
                   new FullBTree<>(6),
                   new FullBTree<>(7)),
              new FullBTree<>(5));

      testBtree(btree3, 3);

      final BTreeNode<Integer> btree4 =
           new BTreeNode<>(101,
               new BTreeNode<>(102,
                   new BTreeNode<>(104),
                   new BTreeNode<>(105)),
               new BTreeNode<>(103,
                   new EmptyBTree<>(),
                   new BTreeNode<>(107)));

      testBtree(btree4, 4);

      final BTree<Integer> btree5 =
           new BTreeNode<>(1001,
                           BTreeAbstract.convert(btree3),
                           btree4);

      testBtree(btree5, 5);
   }

   public static <T> void testBtree(BTree<T> btree, int number)
   {
      System.out.println("\n==== Binary Tree number " + number);
      System.out.println( btree );
      System.out.println( PrettyPrinter.prettyPrint( btree ) + "\n" );
      BTree2dot.btree2dot(btree, "example" + number);
      BTree2png.btree2png("example" + number);

      System.out.println("degree = " + btree.degree());
      System.out.println("height =  " + btree.height());
      System.out.println("size = " + btree.size());
      System.out.println("isFull = " + btree.isFull());

      System.out.println( btree.preOrder() );
      System.out.println( btree.preOrderV2() );
      btree.preOrderV3(); System.out.println();

      System.out.println( btree.inOrder() );
      System.out.println( btree.inOrderV2() );
      btree.inOrderV3(); System.out.println();

      System.out.println( btree.postOrder() );
      System.out.println( btree.postOrderV2() );
      btree.postOrderV3(); System.out.println();
   }
}
